function AllInOneInventoryFrame_UpdateLook(frame, frameSize)
	if ( not frame ) then
		frame = getglobal("AllInOneInventoryFrame");
	end
	if ( ( not frameSize ) or ( frameSize == 0 ) ) then
		frameSize = AllInOneInventory_GetBagsTotalSlots()
	end
	if ( not frame ) or ( not frameSize ) or ( frameSize == 0 )then
		AIOI_ScheduleByName_IfNotImmediate("AIOI_UPDATE_LOOK", 1, AllInOneInventoryFrame_UpdateLook, frame, frameSize);
	else
		AIOI_ScheduleByName("AIOI_UPDATE_LOOK", 1, AllInOneInventoryFrame_DoNothing);
	end
	AllInOneInventory_CreateButtons(frame);
	frame.size = frameSize;

	local name = frame:GetName();
--	local bgTexture = getglobal(name.."BackgroundTexture");
	getglobal(name.."MoneyFrame"):Show();
	local columns = AllInOneInventory_Columns;
	if (columns > frame.size) then columns = frame.size; end -- doesn't make sense to have more columns than slots, just in case sarf decides to increase the upper limit
	if ( columns <= 0 ) then
		columns = 8;
	end
	local rows = ceil(frame.size / columns);
	if ( rows <= 0 ) then
		rows = 1;
	end
	-- Added a short name, in case the long name doesn't fit ;)
	if (columns <= 4) then
		getglobal(name.."Name"):SetText(ALLINONEINVENTORY_BAG_TITLE_SHORT);
	else
		getglobal(name.."Name"):SetText(ALLINONEINVENTORY_BAG_TITLE_LONG);
	end

	local oldHeight = frame:GetHeight();
	local height = AllInOneInventoryFrame_GetAppropriateHeight(rows);
	frame:SetHeight(height);

	local oldWidth = frame:GetWidth();
	local width = AllInOneInventoryFrame_GetAppropriateWidth(columns);
	frame:SetWidth(width);
	if ( frame:IsVisible() ) then
		frame:Show();
	end

--	bgTexture:Hide();

	local diffHeight = ceil(height - oldHeight);
	local diffWidth = ceil(width - oldWidth);

	if ( ( ( diffHeight > 1 ) or ( diffHeight < -1 ) ) or ( ( diffWidth > 1 ) or ( diffWidth < -1 ) ) ) then
		--AllInOneInventoryFrame_ResetPosition(frame);
	end

	-- texture code to make it look like a normal bag...
	local lastColumnIsComplete = false;
	if (rows == floor(frame.size / columns)) then lastColumnIsComplete = true; end

	-- set textures for moneyframe:
	getglobal(name.."TextureBottomMiddle"):SetWidth((columns - 2) * 42 + 70);

	AllInOneInventory_ShowTextures_FirstRow_Old(frame, frameSize, columns, rows);

	AllInOneInventory_ShowTextures_Old(frame, frameSize, columns, rows);

	getglobal(name.."TextureTopMiddle"):SetWidth((columns - 2) * 42 + 22);
	if (lastColumnIsComplete) then
		local textureOffsetX = 0; if (frame.size == columns) then textureOffsetX = -3; end
		getglobal(name.."TextureTopRight"):SetTexture("Interface\\AddOns\\AllInOneInventory\\Skin\\top_right_large");
		getglobal(name.."TextureTopRight"):SetPoint("BOTTOMLEFT", name.."ItemTexture"..((rows - 1) * columns + 1), "TOPLEFT", 19 + textureOffsetX, 0);
		getglobal(name.."TextureTopMiddle"):SetPoint("BOTTOMRIGHT", name.."TextureTopRight", "BOTTOMLEFT", 0, -34);
		getglobal(name.."CloseButton"):SetPoint("BOTTOMLEFT", name.."TextureTopRight", "BOTTOMLEFT", 4, 12);
	else
		getglobal(name.."TextureTopRight"):SetTexture("Interface\\AddOns\\AllInOneInventory\\Skin\\top_right_small");
		getglobal(name.."TextureTopRight"):SetPoint("BOTTOMLEFT", name.."ItemTexture"..((rows - 1) * columns + 1), "TOPLEFT", 19, 0);
		getglobal(name.."TextureTopMiddle"):SetPoint("BOTTOMRIGHT", name.."TextureTopRight", "BOTTOMLEFT", 0, -51);
		getglobal(name.."CloseButton"):SetPoint("BOTTOMLEFT", name.."TextureTopRight", "BOTTOMLEFT", 4, -5);
	end


	AllInOneInventory_OrganizeButtons(frame, columns);
end



function AllInOneInventory_SetNormalTexture(button, texture)
	button:SetNormalTexture(texture);
    button:GetNormalTexture():SetBlendMode("BLEND")
    button:GetNormalTexture():SetPoint("CENTER", button:GetName(), "CENTER", 0, 1)
end

function AllInOneInventory_ShowTextures_FirstRow_Old(frame, frameSize, columns, rows)
	-- show the first row (assumes that columns < frame.size)
	local texture = getglobal(name.."ItemTexture1");
	if ( texture ) then
		texture:SetTexture("Interface\\AddOns\\AllInOneInventory\\Skin\\first_right");
		texture:SetBlendMode("BLEND");
		texture:SetPoint("TOPLEFT", frame:GetName().."TextureBottomRight", "TOPLEFT", -35, 43);
		texture:Show();
	end
	for i=2, (columns-1), 1 do
		local texture = getglobal(name.."ItemTexture"..i);
		if ( texture ) then
			texture:SetTexture("Interface\\AddOns\\AllInOneInventory\\Skin\\first_middle");
			texture:SetBlendMode("BLEND");
			texture:SetPoint("TOPLEFT", frame:GetName().."ItemTexture"..(i - 1), "TOPLEFT", -42, 0);
			texture:Show();
		end
	end
	local texture = getglobal(name.."ItemTexture"..columns);
	if ( texture ) then
		texture:SetTexture("Interface\\AddOns\\AllInOneInventory\\Skin\\first_left");
		texture:SetBlendMode("BLEND");
		texture:SetPoint("TOPLEFT", frame:GetName().."ItemTexture"..(columns - 1), "TOPLEFT", -47, 0);
		texture:Show();
	end
end


function AllInOneInventory_ShowTextures_FirstRow(frame, frameSize, columns, rows)
	local setTex = AllInOneInventory_SetNormalTexture;
	-- show the first row (assumes that columns < frame.size)
	local button = AllInOneInventory_GetItemButton(frame, 1);
	if ( button ) then
		frame.ItemUpperLeft = button;
		setTex(button, "Interface\\AddOns\\AllInOneInventory\\Skin\\first_right");
		button:SetPoint("TOPLEFT", frame:GetName().."TextureBottomRight", "TOPLEFT", -35, 43);
		button:Show();
	end
	for i=2, (columns-1), 1 do
		local button = AllInOneInventory_GetItemButton(frame, i);
		if ( button ) then
			setTex(button, "Interface\\AddOns\\AllInOneInventory\\Skin\\first_middle");
			button:SetPoint("TOPLEFT", AllInOneInventory_GetItemButton(frame, i - 1):GetName(), "TOPLEFT", -42, 0);
			button:Show();
		end
	end
	local button = AllInOneInventory_GetItemButton(frame, columns);
	if ( button ) then
		setTex(button, "Interface\\AddOns\\AllInOneInventory\\Skin\\first_left");
		button:SetPoint("TOPLEFT", AllInOneInventory_GetItemButton(frame, columns - 1):GetName(), "TOPLEFT", -47, 0);
		button:Show();
	end
end

function AllInOneInventory_ShowTextures(frame, frameSize, columns, rows)
	local setTex = AllInOneInventory_SetNormalTexture;
	-- show the other rows
	for j=1, (rows - 1), 1 do
		local button = AllInOneInventory_GetItemButton(frame, j * columns + 1);
		if ( button ) then
			setTex(button, "Interface\\AddOns\\AllInOneInventory\\Skin\\second_right");
			local textureOffsetX = 0; if (j == 1) then textureOffsetX = -3; end
			button:SetPoint("TOPLEFT", AllInOneInventory_GetItemButton(frame, (j - 1) * columns + 1):GetName(), "TOPLEFT", textureOffsetX, 41);
			button:Show();
		end
		local slotsInRow = columns;
		if ((j + 1) * columns > frame.size) then slotsInRow = frame.size - (j * columns); end
		for i=2, (slotsInRow - 1), 1 do
			local button = AllInOneInventory_GetItemButton(frame, j * columns + 1);
			if ( button ) then
				setTex(button, "Interface\\AddOns\\AllInOneInventory\\Skin\\second_middle");
				button:SetPoint("TOPLEFT", AllInOneInventory_GetItemButton(frame, j * columns + i - 1):GetName(), "TOPLEFT", -42, 0);
				button:Show();
			end
		end
		if (slotsInRow == columns) then
			local button = AllInOneInventory_GetItemButton(frame, j * columns + 1);
			if ( button ) then
				setTex(button, "Interface\\AddOns\\AllInOneInventory\\Skin\\second_left");
				button:SetPoint("TOPLEFT", AllInOneInventory_GetItemButton(frame, j * columns + slotsInRow - 1):GetName(), "TOPLEFT", -44, 0);
				button:Show();
			end
		elseif (slotsInRow > 1) then
			local button = AllInOneInventory_GetItemButton(frame, j * columns + 1);
			if ( button ) then
				setTex(button, "Interface\\AddOns\\AllInOneInventory\\Skin\\second_middle");
				button:SetPoint("TOPLEFT", AllInOneInventory_GetItemButton(frame, j * columns + slotsInRow - 1):GetName(), "TOPLEFT", -42, 0);
				button:Show();
			end
		end
	end
end

function AllInOneInventory_ShowTextures_Old(frame, frameSize, columns, rows)
	-- show the other rows
	for j=1, (rows - 1), 1 do
		local texture = getglobal(name.."ItemTexture"..(j * columns + 1));
		if ( texture ) then
			texture:SetTexture("Interface\\AddOns\\AllInOneInventory\\Skin\\second_right");
			texture:SetBlendMode("BLEND");
			local textureOffsetX = 0; if (j == 1) then textureOffsetX = -3; end
			texture:SetPoint("TOPLEFT", frame:GetName().."ItemTexture"..((j - 1) * columns + 1), "TOPLEFT", textureOffsetX, 41);
			texture:Show();
		end
		local slotsInRow = columns;
		if ((j + 1) * columns > frame.size) then slotsInRow = frame.size - (j * columns); end
		for i=2, (slotsInRow - 1), 1 do
			local texture = getglobal(name.."ItemTexture"..(j * columns + i));
			if ( texture ) then
				texture:SetTexture("Interface\\AddOns\\AllInOneInventory\\Skin\\second_middle");
				texture:SetBlendMode("BLEND");
				texture:SetPoint("TOPLEFT", frame:GetName().."ItemTexture"..(j * columns + i - 1), "TOPLEFT", -42, 0);
				texture:Show();
			end
		end
		if (slotsInRow == columns) then
			local texture = getglobal(name.."ItemTexture"..(j * columns + slotsInRow));
			if ( texture ) then
				texture:SetTexture("Interface\\AddOns\\AllInOneInventory\\Skin\\second_left");
				texture:SetBlendMode("BLEND");
				texture:SetPoint("TOPLEFT", frame:GetName().."ItemTexture"..(j * columns + slotsInRow - 1), "TOPLEFT", -44, 0);
				texture:Show();
			end
		elseif (slotsInRow > 1) then
			local texture = getglobal(name.."ItemTexture"..(j * columns + slotsInRow));
			if ( texture ) then
				texture:SetTexture("Interface\\AddOns\\AllInOneInventory\\Skin\\second_middle");
				texture:SetBlendMode("BLEND");
				texture:SetPoint("TOPLEFT", frame:GetName().."ItemTexture"..(j * columns + slotsInRow - 1), "TOPLEFT", -42, 0);
				texture:Show();
			end
		end
	end
end

